#!/usr/bin/python

import sys,os,re,getopt

# this will have target -> depdencies relationship
dep_dict = {}
file_index = {}

# this will have dependencies -> target relationship
# like reverse mapping
rev_dep_dict = {}
rev_file_index = {}

log_file_name = "make.log"
output_filename = ""

base_dir = ""
src_dir = ""
def main(argv):
	i_flag = False
	t_flag = False
	x_flag = False
	r_flag = False

	global output_filename
	global log_file_name
	global src_dir
	
	try:
		opt,args = getopt.getopt(argv,"ho:s:itxr",["help","output=","source="])
	except getopt.GetoptError, err:
		print str(err)
		usage()
		sys.exit(2)		
	if len(args) > 1:
		print "More than 1 argument provided"
		usage()
		sys.exit(2)
	elif len(args) == 1:
		log_file_name = args[0]

	for o,a in opt:
		if o in ("-h","--help"):
			usage()
			sys.exit(0)
		elif o in ("-o","--output"):
			output_filename = a
		elif o in ("-i"):
			i_flag = True
		elif o in ("-t"):
			t_flag = True
		elif o in ("-x"):
			x_flag = True
		elif o in ("-r"):
			r_flag = True
		elif o in ("-s","--source"):
			src_dir = a
		else:
			print "Invalid options "+o
			usage()
			sys.exit(2)

	if (i_flag and t_flag) or (i_flag and x_flag) or (t_flag and x_flag):
		print "-i,-t and -x are mutually exclusive"
		usage()
		sys.exit(2)
	
	if output_filename != "" and not (t_flag or x_flag):
		print "-o is valid only with -t or -x"
		usage()
		sys.exit(2)

	if output_filename == "" and t_flag:
		output_filename = "cc1.txt"
	elif output_filename == "" and x_flag:
		output_filename = "cc1.xml"

	# set the default option
	if not (i_flag or t_flag or x_flag or src_dir != ""):
		usage()
		sys.exit(0)
	#
	# lets start parsing !
	#
	parse(log_file_name)
	if i_flag:
		interactive(r_flag)
	elif t_flag:
		if not r_flag:
			search_by_name("^cc1$",25,o_file_name=output_filename,rev=r_flag)
		else:
			search_by_name(".*",25,o_file_name=output_filename,rev=r_flag)

	elif x_flag:
		xml_file = open(output_filename,"w")
		r = re.compile("^cc1$")
		cc1_target = filter(r.search,file_index.keys())
		print_tree_xml(file_index[cc1_target[0]][0],0,xml_file)

				

	
def uniq(input):
	output = []
	for x in input:
		if x not in output:
			output.append(x)
  	return output

def add_to_dep(file_f,dep_list):
	if dep_list == None:
		print "Empty dependcy "+file_f
		sys.exit(2)

	if file_f in dep_dict:
		print "Error "+file_f+" already exists"
		print file_f,str(dep_list)+" old:"+str(dep_dict[file_f])
		sys.exit(2)
	else:
		dep_dict[file_f] =[]
		if isinstance(dep_list,str):
			dep_dict[file_f].append(dep_list)
		else:
			for dep in dep_list:
				dep_dict[file_f].append(dep)



def parse(make_log_f):

	#
	# Normalize the line breaks using back slash in 
	# the make file log and create a temp file 
	# for it
	#
	os.system("awk '{if($0~/ \\\\$/){printf \"%s\",substr($0,0,length($0)-1)}else{print}}' "+make_log_f+" >.flat.txt")
	dir_stack = []
	global base_dir 

	f = open(".flat.txt","r")

	for line in f:
		split_line = line.split()

		# directory entering and leaving
		if re.match("^make\[[0-9]\]*",line):
			if split_line[1] == "Entering":
				if base_dir == "":
					base_dir = split_line[-1][1:-1]

				dir_stack.append(split_line[-1][1:-1])
#					replace(base_dir,"$BUILD"))
			elif split_line[1] == "Leaving":
				dir_stack.pop()

		# only compilation commands
		elif re.search("gcc -c",line):
			c_file = ""
			o_file = ""
			for i in range(0,len(split_line)):
				if re.search("\.c$",split_line[i]):
					path_j = os.path.join(dir_stack[-1],split_line[i])
					c_file = os.path.normpath(path_j)
				elif re.search("\-o$",split_line[i]):
					if split_line[i+1][-1] == ";":
						path_j = os.path.join(dir_stack[-1],split_line[i+1][:-1])
					else:
						path_j = os.path.join(dir_stack[-1],split_line[i+1])
					
					o_file = os.path.normpath(path_j)
			#
			# it is possible that object file name is
			# implied by the c file name
			if o_file == "":
				o_file = os.path.join(dir_stack[-1],c_file.split('/')[-1][:-2]+".o")
				#print "CMP "+o_file,c_file
				add_to_dep(o_file,c_file)
			else:
				#print "CMP "+o_file,c_file
				add_to_dep(o_file,c_file)
			
		# this has both compilation commands and linking commnads
		elif re.match("gcc ",line) or re.search("libtool=no gcc ",line):			
			#
			# First find out whether it has option -c 
			# to discriminate between compilation and linking
			#
			is_compile = "-c" in split_line


			if is_compile:
				o_file = ""
				c_file = ""
				for i in range(0,len(split_line)):
					if re.search("\.c$",split_line[i]):
						path_j = os.path.join(dir_stack[-1],split_line[i])
						c_file = os.path.normpath(path_j)
					elif re.search("\.o$",split_line[i]):
						path_j = os.path.join(dir_stack[-1],split_line[i])
						o_file = os.path.normpath(path_j)
				#
				# it is possible that object file name is
				# implied by the c file name
				if o_file == "":
					o_file = os.path.join(dir_stack[-1],c_file.split('/')[-1][:-2]+".o")
					#print "CMP "+o_file,c_file
					add_to_dep(o_file,c_file)
				else:
					#print "CMP "+o_file,c_file
					add_to_dep(o_file,c_file)
			else:
				# 
				# it includes object file, archive file and executable
				# and keep a list of object files and archive files
				e_file = ""
				oa_files = []
				for i in range(0,len(split_line)):
					if re.search("\.[oa]$",split_line[i]):
						path_j = os.path.join(dir_stack[-1],split_line[i])
						oa_files.append(os.path.normpath(path_j))
					elif re.search("\-o$",split_line[i]):
						path_j = os.path.join(dir_stack[-1],split_line[i+1])
						e_file = os.path.normpath(path_j)

				#print "LNK "+e_file,
				#for oa in oa_files:
				#	print oa,
				#print ""
				add_to_dep(e_file,oa_files)

		#
		# parse archive files 	, contain obj files and an archive file
		# there are two archive commands to handle files inside pic
		# we deliberately ignore them since it isn't used in cc1
		# 
		elif re.match("ar ",line):
			a_file = ""
			o_files = []
			for i in range(0,len(split_line)):
				if re.search("\.a$",split_line[i]):
					path_j = os.path.join(dir_stack[-1],split_line[i])
					a_file = os.path.normpath(path_j)
				elif re.search("\.o$",split_line[i]):
					path_j = os.path.join(dir_stack[-1],split_line[i])
					o_files.append(os.path.normpath(path_j))

			#print "ARC "+a_file,
			#for o in o_files:
			#	print o,
			#print ""
			add_to_dep(a_file,o_files)

		# 
		# this is a special gen* comand which has move-if-change
		# with in itself , so parse this before move-if-change 
		#
	
		elif re.match("build/genchecksum ",line):
			gen_file = ""
			oa_files = []

			cksum_cmd = line.split("&&")[0]
			move_cmd = line.split("&&")[1]
		

		
			split_line = cksum_cmd.split()
			path_j = os.path.join(dir_stack[-1],split_line[0])
			gen_file = os.path.normpath(path_j)
			for oa in split_line[1:-2]:
				path_j = os.path.join(dir_stack[-1],oa)
				oa_files.append(os.path.normpath(path_j))
			path_j = os.path.join(dir_stack[-1],split_line[-1])
			tmp_file = os.path.normpath(path_j)

			oa_files.append(gen_file)

			#print "GEN "+tmp_file,
			#for oa in oa_files:
			#	print oa,
			#print ""

			add_to_dep(tmp_file,oa_files)
	
			split_line = move_cmd.split()
			path_j = os.path.join(dir_stack[-1],split_line[1])
		        src_file = os.path.normpath(path_j)
		        path_j = os.path.join(dir_stack[-1],split_line[2])
		        dst_file = os.path.normpath(path_j)
		        #print "MVC "+dst_file,src_file
		
			add_to_dep(dst_file,src_file)			
	
		# 
		# parse move-if-change commands 
		#
		elif re.search("move\-if\-change ",line):
			# 
			# only consider if it is moving a C file or MD file
			# otherwise ignore it
			#
			if re.search("\.(md|c)$",split_line[-1]) :
				path_j = os.path.join(dir_stack[-1],split_line[2])
				src_file = os.path.normpath(path_j)
				path_j = os.path.join(dir_stack[-1],split_line[3])
				dst_file = os.path.normpath(path_j)
				#print "MVC "+dst_file,src_file
				add_to_dep(dst_file,src_file)

	
		# 
		# gen* commands output parsing
		#
		# gen* > *.out
		#
		elif re.match("build/(genmodes|gencondmd) >",line):
			path_j = os.path.join(dir_stack[-1],split_line[2])
			out_file = os.path.normpath(path_j)
			#print "GEN "+out_file,os.path.join(dir_stack[-1],split_line[0])

			add_to_dep(out_file,os.path.join(dir_stack[-1],split_line[0]))

		elif re.match("build/genmodes -m",line):
			path_j = os.path.join(dir_stack[-1],split_line[3])
			c_file = os.path.normpath(path_j)
			#print "GEN "+c_file,os.path.join(dir_stack[-1],split_line[0])

			add_to_dep(c_file,os.path.join(dir_stack[-1],split_line[0]))
		#
		# gen* *.md > *.c
		#
		elif re.match("build/(genconditions|genenums|genpreds) ",line):
			if "-c" in split_line or "-h" in split_line:
				continue

			path_j = os.path.join(dir_stack[-1],split_line[3])
			c_file = os.path.normpath(path_j)
	
			path_j = os.path.join(dir_stack[-1],split_line[0])
			gen_file = os.path.normpath(path_j)
	
			path_j = os.path.join(dir_stack[-1],split_line[1])
			md_file = os.path.normpath(path_j)

			#print "GEN "+c_file,md_file,gen_file

			add_to_dep(c_file,[md_file,gen_file])
		# gen*  *.md *.md  > *.c		
		elif re.match(\
			"build/(genautomata|genattrtab|genemit|genextract|genopinit|genoutput|genpeep|genrecog) "\
				,line):
			path_j = os.path.join(dir_stack[-1],split_line[4])
		        c_file = os.path.normpath(path_j)

		        path_j = os.path.join(dir_stack[-1],split_line[0])
		        gen_file = os.path.normpath(path_j)

		        path_j = os.path.join(dir_stack[-1],split_line[1])
		        md1_file = os.path.normpath(path_j)
		        
			path_j = os.path.join(dir_stack[-1],split_line[2])
		        md2_file = os.path.normpath(path_j)
		
			#print "GEN "+c_file,md1_file,md2_file,gen_file
	
			add_to_dep(c_file,[md1_file,md2_file,gen_file])

	# 
	# build index for searching targets 
	#
	for k in dep_dict.keys():
		f_name = k.split('/')[-1]
		if f_name not in file_index:
			file_index[f_name] = []
		file_index[f_name].append(k)
	# 
	# build reverse mapping using the already built
	# dep_dict
	#
	for k,v in dep_dict.items():
		for value in v:
			if value not in rev_dep_dict:
				rev_dep_dict[value] = []
			rev_dep_dict[value].append(k)
	#
	# build index for searching dependencies
	#
	for k in rev_dep_dict.keys():
		f_name = k.split('/')[-1]
		if f_name not in rev_file_index:
			rev_file_index[f_name] = []
		rev_file_index[f_name].append(k)

def print_tree_xml(target,level,xml_file):
	xml_file.write("<dep name=\""+target.replace(base_dir,"$BUILD").\
			replace(src_dir,"$SOURCE/")+"\" level=\""+str(level)+"\" >\n")
	level = level+1
	if target in dep_dict:
		uniq_deps = uniq(dep_dict[target])
		uniq_deps.sort()
		for dep in uniq_deps:
			print_tree_xml(dep,level,xml_file)
	xml_file.write("</dep>\n")

def print_tree_lvl(target,alignment,level,o_file=None,rev=False):
	global base_dir
	global src_dir
	if not o_file:
		print alignment+""+target.replace(base_dir,"$BUILD").replace(src_dir,"$SOURCE/")
	else:
		o_file.write(alignment+""+target.replace(base_dir,"$BUILD").\
				replace(src_dir,"$SOURCE/")+"\n")
	if not rev:
        	alignment = alignment+"|--"
		data_dict = dep_dict
	else:
        	alignment = alignment+"^--"
		data_dict = rev_dep_dict
	
        if target in data_dict:
		uniq_deps = uniq(data_dict[target])
		uniq_deps.sort()
                for dep in uniq_deps:
			if level:
				print_tree_lvl(dep,alignment,level-1,o_file=o_file,rev=rev)
        elif not rev and not re.search("\.(c|md)$",target):
                print "Warning: Non C file as leaf "+target




def search_by_name(re_pat,level,o_file_name=None,rev=False):
	if o_file_name:
		o_file = open(o_file_name,"w")
	else:
		o_file = None
	if not rev:
		index = file_index
	else:
		index = rev_file_index

	regex = re.compile(re_pat)
	matched_keys = filter(regex.search,index.keys())

	for k in matched_keys:
		for d in index[k]:
			print " **************** "+d+" ********************\n"
			print_tree_lvl(d,"",level,o_file=o_file,rev=rev)
			print ""

def interactive(rev=False):
	while True:
		try:
			print "Ctrl + D to exit"
			regex = raw_input("Enter the file name [^cc1$]:")
			if regex == "":
				regex = "^cc1$"
	
			level_str = raw_input("Enter the level [1]:")
			if level_str == "":
				level = 1
			else:
				level = int(level_str)
		
			search_by_name(regex,level,o_file_name=None,rev=rev)

		except EOFError:
			print "\nExiting"
			sys.exit(0)


def usage():
	print "Usage: "+sys.argv[0]+" [options] -s src_dir <log_filename>"
	print "options"
	print "\t-h, --help		show this help message"
	print "\t-s, --source=src_dir	dir which will apprear as $SOURCE"
	print "\t-r 			uses reverse mapping "
	print "\t			from source -> target"
	print "\t-i			enter interactive search"
	print "\t-o, --output=filename	output file name for -x and -t"
	print "\t-t 			store the tree in output file"
	print "\t-x			store the XML format in a output file"
	print "\t-x,-i and -t are mutually exclusive options\n"
	print "default file name for -x is cc1.xml"
	print "default file name for -t is cc1.txt"
	print "log_filename is optional and by default it is make.log\n"


if __name__ == "__main__":
	main(sys.argv[1:])

